<template>
    <q-page class="bg-base q-pa-lg">
        <DocumentWrapper ref="wrap">
            <ListPage :desktop="4">
                <Form title="Create Floor" :fields="fields"
                      :on-submit="Submit"
                      @unknown="SubmitError"
                      @auth="SubmitError"
                      v-model="model"
                      @success="SubmitSuccess">
                </Form>
            </ListPage>
        </DocumentWrapper>
    </q-page>
</template>

<style lang='scss' scoped>

</style>

<script lang='ts'>
import Vue from 'vue';
import {Component} from 'vue-property-decorator';
import {FloorResponse} from "src/classLibrary/APIModels/core/floorResponse";
import Form from "components/Form.vue";
import {BasicFormModel, FormInput} from "src/classLibrary/FormTypes";
import DocumentWrapper from "components/Core/DocumentWrapper.vue";
import ListPage from "components/Core/ListPage.vue";
import {ApiError} from "src/classLibrary/Core/Api";

@Component({
    components: {ListPage, DocumentWrapper, Form}
})
export default class CreateFloor extends Vue {

    get Wrap(): DocumentWrapper {
        return this.$refs.wrap as any;
    }

    SubmitError(e: ApiError) {
        this.Wrap.SubmitError(e);
    }


    model: BasicFormModel = {
        valid: false,
        models: {
            name: '',
            timeZone: '',
        }
    }

    fields: FormInput[] = [
        {
            rules: [
                (v: string) => !!v || 'Please enter the floor name',
                (v: string) => (v.length < 128 && v.length > 1) || 'Floor name has to be between 2 to 128 characters',
            ],
            label: 'Floor Name',
            tooltip: "Name of the floor to track",
            icon: 'icofont-building-alt',
            key: 'name',
            max: 128,
            type: 'text',
            baseType: 'basic',
        },
        {
            baseType: 'select',
            icon: 'icofont-wall-clock',
            tooltip: 'Timezone the project in ran in. This affects analytics and alert calculations',
            key: 'timeZone',
            options: this.Store.StoreValue.timeZone,
            label: 'Time Zone'

        }
    ]


    async Submit(_: any) {
        const t = await this.$auth.CoreToken;
        return await this.$coreApi.Post<FloorResponse>(`Floor/${this.PersistentStore.StoreValue.project}`,
            {
                name: this.model.models.name,
                timeZone: this.model.models.timeZone,
                fields: "{}"
            }, t);
    }

    async SubmitSuccess(a: FloorResponse) {
        this.$q.notify({color: 'positive', message: `Successfully created project ${a.principal.name}`, icon: 'check'});
        await this.$router.push("/floor");
    }
}
</script>
